/**
 * 位置相关接口
 */
import { callNative, emptyFn } from './util';

export default {
    /**
     * 获取当前的地理位置
     *
     * @param {object} options
     * @param {function} options.success 接口调用成功的回调函数，返回内容详见返回参数说明。
     */
    getLocation({
        type = 'wgs84',
        altitude = false,
        success = emptyFn,
        fail = emptyFn,
        complete = emptyFn
    } = {}) {
        const options = {
            type,
            altitude: !!altitude,
            success,
            fail,
            complete
        };

        callNative('getLocation', options, {type: 'String'});
    }
};
